VERSION 5.00
Begin VB.Form Test 
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   8625
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   8325
   BeginProperty Font 
      Name            =   "Courier New"
      Size            =   12
      Charset         =   204
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H00000000&
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   575
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   555
   StartUpPosition =   2  'CenterScreen
End
Attribute VB_Name = "Test"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Sub CopyMemory Lib "SR2D" Alias "COPY_MEMORY" (ByRef Src As Any, ByRef Dest As Any, ByVal Length As Long)

Dim Spr1 As New SR2D_Sprite
Dim Spr2 As New SR2D_Sprite
Dim Ar(511, 511) As Long
Dim Running As Boolean

Const PPCnt As Long = 512
Dim PPX(PPCnt - 1) As Long
Dim PPY(PPCnt - 1) As Long

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
  If KeyCode = vbKeyEscape Then Unload Me
End Sub

Private Sub Form_Load()
  Move Left, Top, Width - Screen.TwipsPerPixelX * (ScaleWidth - 512), Height - Screen.TwipsPerPixelY * (ScaleHeight - 512)
  ScaleMode = vbPixels

  Spr1.LoadFromFile App.Path & "\2.jpg", , 512, 512
  ARGBtoGray Spr1
  Spr1.MulAddS2X Spr1, 0, 0, ARGB(0, 160, 160, 160), ARGB(0, 128, 128, 128)
  Spr2.Init 4096, 4096
  Spr2.ClearBuffer ARGB(0, 255, 255, 255)
  LoadArray
  CreatePP
  Show

  Running = True
  Work 20000
  Spr1.LoadFromSprite Spr2, , 512, 512
  Spr1.PaintToDevice hDC
  If Running = False Then Unload Me
  Running = False
End Sub

Private Sub Form_Paint()
  Spr1.PaintToDevice hDC
End Sub

Private Sub Work(ByVal Cnt As Long)
  Dim i As Long
  Static p1 As Long
  Dim p2 As Long

  For i = 0 To Cnt - 1
    If Not Running Then Exit For
    Caption = i
    DoEvents
    p2 = FindWay(p1)
    Spr2.DrawLine PPX(p1) * 8, PPY(p1) * 8, PPX(p2) * 8, PPY(p2) * 8, ARGB(0, 0, 0, 0)
    p1 = p2
  Next i
End Sub

Private Function FindWay(ByVal p1 As Long) As Long
  Dim i As Long
  Dim FW As Long
  Dim p2 As Long
  Dim L As Long
  Dim LL As Long
  Dim c As Long
  Dim C1 As Single
  Dim C2 As Single
  Dim x As Long, y As Long
  Dim x1 As Long, y1 As Long
  Dim x2 As Long, y2 As Long

  x1 = PPX(p1)
  y1 = PPY(p1)
  C1 = -1000000000
  FW = (p1 + 1) And 511
  For i = 1 To PPCnt - 1
    p2 = (p1 + i) And 511
    x2 = PPX(p2)
    y2 = PPY(p2)
    LL = Abs(x2 - x1)
    If LL < Abs(y2 - y1) Then LL = Abs(y2 - y1)
    c = 0
    For L = 1 To LL
      x = x1 + (x2 - x1) * L \ LL
      y = y1 + (y2 - y1) * L \ LL
      If Ar(x, y) < 255 Then
        c = c + (255 - Ar(x, y))
      Else
        c = c - (Ar(x, y) - 254) * (Ar(x, y) - 254)
      End If
    Next L
    C2 = c / LL
    If C1 < C2 Then
      C1 = C2
      FW = p2
    End If
  Next i

  x2 = PPX(FW)
  y2 = PPY(FW)
  LL = Abs(x2 - x1)
  If LL < Abs(y2 - y1) Then LL = Abs(y2 - y1)
  For L = 1 To LL
    x = x1 + (x2 - x1) * L \ LL
    y = y1 + (y2 - y1) * L \ LL
    Ar(x, y) = Ar(x, y) + 4
  Next L
  FindWay = FW
End Function

Private Sub CreatePP()
  Dim i As Long
  Const Pi As Single = 3.141593

  For i = 0 To PPCnt - 1
    PPX(i) = 255.5 + 255.5 * Sin(2 * Pi * i / PPCnt)
    PPY(i) = 255.5 + 255.5 * Cos(2 * Pi * i / PPCnt)
  Next i
End Sub

Private Sub LoadArray()
  Dim x As Long, y As Long

  For y = 0 To 511
    For x = 0 To 511
      Ar(x, y) = Spr1.GetPixel(x, y) And &HFF
    Next x
  Next y
End Sub

Private Sub ARGBtoGray(Spr As SR2D_Sprite)
  Dim i As Long
  Dim c As Long
  Dim Sz As Long
  Dim B() As Byte

  Sz = 4 * Spr.Width * Spr.Height
  ReDim B(Sz - 1)
  CopyMemory ByVal Spr.DataPTR(0, 0), B(0), Sz
  For i = 0 To Sz - 4 Step 4
    c = (B(i) * 28& + B(i + 1) * 150& + B(i + 2) * 77&) \ 255
    B(i) = c
    B(i + 1) = c
    B(i + 2) = c
  Next i
  CopyMemory B(0), ByVal Spr.DataPTR(0, 0), Sz
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
  If Running Then
    Running = False
    Cancel = 1
  End If
End Sub
